#ifndef	__GPSTREAM_H__
#define	__GPSTREAM_H__

#include "gpstdio.h"

#define	GP_STREAM_SAFE_BLK_GAP	2

#define	GP_STREAM_STATE_EMPTY					1	//Ʈֹۿ ƹ  Ҵ  
#define	GP_STREAM_STATE_STOPPED					2	//Ʈֹۿ  ҴǾ ÷̵  
#define	GP_STREAM_STATE_PLAYING_MORE_DATA		3	//÷.  о Ÿ ִ.
#define	GP_STREAM_STATE_PLAYING_NO_MORE_DATA	4	//÷. ̻ о Ÿ .
#define	GP_STREAM_STATE_PLAYING_STARTED			5	//÷̰ ۵ .

#define	GP_STREAM_ERR_NO_ERROR		0	//
#define	GP_STREAM_ERR_UNKNOWN		-1	//   
#define	GP_STREAM_ERR_MEMORY		-2	//޸ 
#define	GP_STREAM_ERR_FILE			-3	//ȭ  
#define	GP_STREAM_ERR_ALREADY_SET	-4	//̹  ҴǾ ִµ ٸ  ҴϷ ϴ 
#define	GP_STREAM_ERR_BUF_OVERFLOW	-5	//߸  Ҵ
#define	GP_STREAM_ERR_NO_CHANNEL	-6	//ü ã  
#define	GP_STREAM_ERR_TOO_SMALL		-7	//ʹ   Ҵ
#define GP_STREAM_ERR_PCM_FULL		-8

#define	GP_STREAM_ENTER_CRITICAL()
#define	GP_STREAM_EXIT_CRITICAL()

// ʱȭŰ ũ
#define	GP_STREAM_CLEAR_MEMBERS()				\
	g_stream_buf.idx_curr = 0;					\
	g_stream_buf.p_curr = 0;					\
	g_stream_buf.n_read = 0;					\
	g_stream_buf.state = GP_STREAM_STATE_EMPTY;	\
	g_stream_buf.p_filename = NULL;				\
	g_stream_buf.h_file = 0; 					\
	g_stream_buf.idx_chnl = -1;					\
	g_stream_buf.p_curr_playing = NULL;			\
	g_stream_buf.p_last_played = NULL;			\
	g_stream_buf.sz_played = 0;					\
	g_stream_buf.repeated = 1;

typedef struct
{
	int				idx_curr;			//ο Ÿ ؾ   ε
	int				p_curr;				//ο Ÿ ؾ  ġ (   ġ. Ʈ )
	int				sz_buf;				//  (2^sz_buf_exp Ʈ)
	int				sz_blk_exp;			//  
	int				sz_blk;				//÷  (Ʈ )
	int				cnt_blk;			// 
	int				cnt_once;			//ȭϷκ ѹ о  
	int				sz_once;			//ȭϷκ ѹ о ũ (Ʈ )
	int				cnt_init;			//ʱ⿡ ȭϷκ о  
	int				sz_init;			//ʱ⿡ ȭϷκ о ũ (Ʈ )
	int				n_read;				//ݱ ȭϷκ о Ÿ  (Ʈ )
										//***ݺ    ߾ ½Ű ʱ  ÷ο찡   
	unsigned char	*p_buf;				//
	int				state;				//º
	char			*p_once;			//߰  (ȭϷκ ѹ о Ÿ ӽ÷ )
	char			*p_filename;		//ȭϸ
	F_HANDLE		h_file;				//ȭ ڵ
	int				idx_chnl;			//ä
	unsigned short	**p_curr_playing;	// ÷ϰ ִ Ÿ ġ. *** ణ  
	unsigned short	*p_last_played;		// ÷ Ÿ ġ
	int				idx_timer;			//Ÿ̸ ε
	int				sz_played;			// ÷ ŸǾ (Ʈ )
	 									//***ݺ    ߾ ½Ű ʱ  ÷ο찡   
	int				tps;				//Ticks per Second (1ʿ GpStremTask Լ Ǵ ȸ)
	int				repeated;			//ݺ  ***  ݺ 
} TGpStreamBuf;
//ȣ 
//1.GpStreamInit : α׷ ʱ⿡ ѹ ȣ
//2.GpStremSet   :  ÷ϱ    ȣ
//3.GpStreamPlay :  ÷ϱ    ȣ
//4.GpStremEnd   :       ȣ
//
//ĺʹ 2.~4. ݺѴ. 



//ʱȭ Լ. α׷ ʱ⿡   ȣǾ Ѵ.
//idx_timer  : Ÿ̸ ε
//tps        : Ticks per Second
//sz_blk_exp : ũ  (  ũ == 2^sz_blk_exp Ʈ)
//cnt_blk    :      ũ (cnt_blk * (2^sz_blk_exp)) Ʈ ȴ.
//cnt_init   : ʱ⿡ о̴ Ÿ .  ʱ⿡ о̴ Ÿ ũ (cnt_init * (2^sz_blk_exp)) Ʈ ȴ.
int GpStreamInit(int idx_timer, int tps, int sz_blk_exp, int cnt_block, int cnt_once, int cnt_init);		
// Ÿ Ҵϴ Լ
//p_filename : ȭϸ
//repeated   : ݺ 
int GpStreamSet(char *p_filename, int repeated);	
//Ʈ ۸ ʱȭ. (GpStreamEnd ȣ)
int GpStreamReset(void);	
//Ʈ Ÿ ÷
int GpStreamPlay(void);		
//Ʈ Ÿ 
int GpStreamEnd(void);
//Ʈ Ÿ ۾ Լ.  Ÿ̸ ̺Ʈ ̿,  ð  Ǵ  Ǿ ִ.		
void GpStreamTask(void);	
//  ȿ θ ϴ Լ
//void GpPcmOnlyKill(void);

#endif	//__GPSTREAM_H__