//////////////////////////////////////////////////////////////////////////
// Gp32emu.h: GP32 API emulation library header
// Copyright (C) 2008-2009, hardyx
// This library can be used freely under the GNU GPL license.
//////////////////////////////////////////////////////////////////////////

#ifndef _GP32EMU_H
#define _GP32EMU_H

#include "gpdef.h"
#include "gpstdio.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpstdlib.h"
#include "SDL/SDL_main.h"

// separa directorios
#ifdef WIN32
#define SDIR_SEP "\\"
#define CDIR_SEP '\\'
#else
#define SDIR_SEP "/"
#define CDIR_SEP '/'
#endif

// funciones adicionales
void GpVideoInit();
bool GpDirExists(const char *dir_name);
void GpSwapABKeys(short swap);
void GpClockSpeed(int cpu_mhz);

//////////////////////////////////////////
// funciones que se usan en el programa

//GpTickCountGet();
//GpKeyGet()
//GpKeyInit()
//GpGraphicModeSet()
//GpLcdSurfaceGet()
//GpSurfaceSet()
//GpSurfaceFlip()
//GpRectFill16()
//GpPaletteEntryChange()
//GpLcdFadeNormalize()
//GpLcdFade()
//GpRectFill();
//GpFatInit()
//GpDirCreate()
//GpFileAttr()
//GpFileGetSize()
//GpDirEnumList()
//GpFileOpen()
//GpFileCreate()
//GpFileClose()
//GpFileRead()
//GpFileWrite()

#endif // _GP32EMU_H
